<template>
  <ob-form
      :form-data="formData"
      :form-model="formModel"
      :is-loading="isShowLoader"
      @submit="onSubmitHandler"
      :okText="isEdit ? 'Сохранить' : 'Добавить'"
      data-qa="formDirectionBP"
  >
    <div class="row">
      <div class="col-xs-12">
        <div class="form-group">
          <ObSelect
              v-model="formData.locationFromUuid"
              label="Откуда"
              :isTagbox="true"
              :isDropdown="true"
              :required="true"
              :withCheckbox="true"
              :disabled="isEdit"
              placeholder="Выберите одну или несколько локаций"
              :items="locations"
              displayExp="russian_name"
              :is-auto-complete="true"
              @input="resetError"
              data-qa="selectMultipleLocationFromUuidBP"
          />
        </div>
      </div>
      <div class="col-xs-12">
        <div class="form-group">
          <ObSelect
              v-model="formData.locationToUuid"
              label="Куда"
              :isTagbox="true"
              :isDropdown="true"
              :required="true"
              :withCheckbox="true"
              placeholder="Выберите одну или несколько локаций"
              displayExp="russian_name"
              :items="locationsTo"
              :is-auto-complete="true"
              @input="resetError"
              data-qa="selectMultiplelocationToUuidBP"
          />
        </div>
      </div>
    </div>

    <transition name="fadeIn">
      <ObAlert
          v-if="error"
          :text="error"
          class="alert-error"
          theme="danger"
          icon="alert"
          :hide-close-button="true"
      />
    </transition>

  </ob-form>
</template>

<script>
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import ObForm from "common-components/src/obComponents/obForm";
import ObSelect from "common-components/src/obComponents/obSelect";
import ObAlert from "common-components/src/obComponents/obAlert";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import { required } from "vuelidate/lib/validators";
import api from '@/api'

export default {
  name: "BasePriceDirectionForm",
  components: {
    ObForm,
    ObAlert,
    ObSelect,
  },
  mixins: [FormValidationMixin, dropdownEvents],
  props: {
    isEdit: {
      type: Boolean,
      default: () => false
    },
  },
  data () {
    return {
      error: '',
      isShowLoader: false,
      locations: [],
      groupItems: [
        {
          label: 'Целые машины',
          value: 'FTL',
        },
        {
          label: 'Контейнеры',
          value: 'CONTAINER',
        },
        {
          label: 'Вагоны',
          value: 'RAIL',
        },
      ],
    }
  },
  watch: {
    'formData.locationFromUuid' () {
      let data = this.formData;
      if(data.locationToUuid && data.locationFromUuid) {
        data.locationToUuid = data.locationToUuid.filter((uuid) => {
          return !data.locationFromUuid.find(m => m === uuid);
        });
      }
    },
  },
  computed: {
    formModel() {
      return {
        groupUuid: {
          value: '',
        },
        directionUuid: {
          value: '',
        },
        locationFromUuid: {
          value: null,
          validator: {
            required
          }
        },
        locationToUuid: {
          value: null,
          validator: {
            required
          }
        },
      }
    },
    locationsTo() {
      return this.locations.filter( ( el ) => {
        if( !this.formData.locationFromUuid ){
          return el;
        }else{
          return !this.formData.locationFromUuid.find(m => m === el.uuid);
        }
      });
    }
  },
  mounted() {
    let locationsParams = {
      query: '',
      page: 0,
      size: 10000,
      filters: {
        location_type_uuid: '5919a99f-d840-4855-b158-5ba957076603', // только опорники
      }
    }
    this.getLocations(locationsParams);
  },
  methods: {
    async onSubmitHandler() {
      let data = {...this.formData};
      this.isShowLoader = true;
      if (!this.isEdit) {
        try {
          await api.base_prices_clustering.createDirection(data.groupUuid, data)
              .then((res) => {
                this.$notification({
                  type: "system_notification_success",
                  message: "Направление успешно создано",
                });
                this.$emit("save", {formData: res});
              })
              .catch((err) => {
                console.error("error ->", err);
                if (err.error) {
                  this.error = err.error_message;
                }
              })
              .finally(() => {
                this.isShowLoader = false;
              });
        } catch (e) {
          this.isShowLoader = false;
          this.$notification({type: 'system_notification_error', message: 'Ошибка сохранения направления'});
          this.error = 'Ошибка создания направления';
        }
      } else {
        try {
          await api.base_prices_clustering.updateDirection(data.groupUuid, data.directionUuid, data.locationToUuid)
            .then((res) => {
              this.$notification({
                type: "system_notification_success",
                message: "Спосок локаций обновлен",
              });
              this.$emit("save", {formData: res});
            })
            .catch((err) => {
              console.error("error ->", err);
              if (err.error) {
                this.error = err.error_message;
              }
            })
            .finally(() => {
              this.isShowLoader = false;
            });
        } catch (e) {
          this.isShowLoader = false;
          this.$notification({type: 'system_notification_error', message: 'Ошибка обновления списка локаций'});
          this.error = 'Ошибка обновления списка локаций';
        }
      }
    },
    async getLocations({ query = '', page = 0, size = 10000, filters }) {
      try {
        const data = await api.locations.getLocations(page, size, query, [], filters);
        this.locations = data.data.content;
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
        return [];
      }
    },
    resetError() {
      this.error = '';
    },
    close() {
      this.$emit('close')
    },
  }
};
</script>

<style lang="scss">
@import "~common-components/src/static/css/mixins";
.form-group {
  justify-content: space-between;
  align-self: flex-start;
  margin-bottom: 20px;

  &__title {
    @include font-mixin(20px, 28px, 700, #191E32, 0.4px);
    margin-bottom: 10px;
  }

  &__label {
    @include font-mixin(14px, 18px, 400, #737682, 0.2px);
    margin-bottom: 15px;
  }

  .input-group .input{
    color: $cobalt-black;
  }
}
</style>